//  Shapes.h
////////////////////////////////////////////////////
//  

class CBasePoint: public CObject
{
 	DECLARE_SERIAL(CBasePoint)
 protected:	//   
	virtual void Serialize(CArchive& ar);
 public:		
	//
	CBasePoint(int x, int y); //  
	CBasePoint();//  
	~CBasePoint(){}; //
// 
	double m_dScale; // 
	LONG m_x; //  X
	LONG m_y; //  Y
// 
	//     -  
	virtual void Show(CDC *pDC);
	//     
	virtual void GetRegion(CRgn &Rgn);
	//e   point
	//   point0,   ang,
	//    ,    b 
	CPoint Transform(	const CPoint &point, 
			const CPoint &point0, double ang, int a, int b);
};

////////////////////////////////////////////////////
// 
class CCircle: public CBasePoint
{
 	DECLARE_SERIAL(CCircle)   
 protected:  	//   	
	virtual void Serialize(CArchive& ar);
 public:		
	//
	CCircle(int x, int y, WORD r);
	CCircle();
	~CCircle(){};
//
	WORD m_wRadius; // 
//
	//    
	virtual void Show(CDC *pDC);
	//     
	virtual void GetRegion(CRgn &Rgn);
};

////////////////////////////////////////////////////
// 
class CSquare: public CBasePoint
{
 	DECLARE_SERIAL(CSquare)   
 protected:  	//   	
	virtual void Serialize(CArchive& ar);
 public:		
	//
	CSquare(int x, int y, WORD s);
	CSquare();
	~CSquare(){};
//
	WORD m_wSide; // 
//
	//    
	virtual void Show(CDC *pDC);
	//     
	virtual void GetRegion(CRgn &Rgn);
};

////////////////////////////////////////////////////
// 
#define MAXPOLIGONLENGTH 100
class CPoligon: public CBasePoint
{
 	DECLARE_SERIAL(CPoligon)   
 protected:	//   	
	virtual void Serialize(CArchive& ar);
 public:		
	//
	CPoligon();
	~CPoligon();
//
	POINT m_Points[MAXPOLIGONLENGTH]; //  
	WORD m_nIndex;
//
	//    
	virtual void Show(CDC *pDC);
	//     
	virtual void GetRegion(CRgn &Rgn);
	// 
	BOOL AddPoint(CPoint point);
};

