// Paintdoc.cpp : implementation of the CPainterDoc class
//

#include "stdafx.h"
#include "Painter.h"
#include "Paintdoc.h"
#include "Shapes.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPainterDoc

IMPLEMENT_DYNCREATE(CPainterDoc, CDocument)

BEGIN_MESSAGE_MAP(CPainterDoc, CDocument)
	//{{AFX_MSG_MAP(CPainterDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPainterDoc construction/destruction

CPainterDoc::CPainterDoc()
{
	// TODO: add one-time construction code here
	m_nIndex=0;	
	m_pCurShape=NULL;
}

CPainterDoc::~CPainterDoc()
{
	while(m_ShapesList.GetCount()>0)
		delete m_ShapesList.RemoveHead();
}

BOOL CPainterDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	m_nIndex=0;
	while(m_ShapesList.GetCount()>0)
		delete m_ShapesList.RemoveHead();
	
	m_pCurShape=NULL;
	
	UpdateAllViews(NULL);
	
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CPainterDoc serialization

void CPainterDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
		ar << m_nIndex;
		for(int i=0; i<m_nIndex; i++) ar << m_Points[i];
	}
	else
	{
		// TODO: add loading code here
		ar >> m_nIndex;
		for(int i=0; i<m_nIndex; i++) ar >> m_Points[i];
	}
	m_ShapesList.Serialize(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CPainterDoc diagnostics

#ifdef _DEBUG
void CPainterDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CPainterDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CPainterDoc commands

void CPainterDoc::AddShape(CBasePoint* pShape)
{
	m_ShapesList.AddTail(pShape);
	m_pCurShape=pShape;	
};

BOOL CPainterDoc::DeleteLastShape()
{
	if(m_ShapesList.GetCount()>0)
	{
		delete m_ShapesList.RemoveTail();
		if(m_ShapesList.GetCount()>0) 
			m_pCurShape=(CBasePoint*)m_ShapesList.GetTail();
		else m_pCurShape=NULL;
		return TRUE;
	}
	else return FALSE;
};


void CPainterDoc::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if(m_pCurShape!=NULL) 
		m_pCurShape->OnKeyDown( nChar, nRepCnt, nFlags);
}; //

void CPainterDoc::OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if(m_pCurShape!=NULL) 
		m_pCurShape->OnKeyUp( nChar, nRepCnt, nFlags);
};   //

BOOL CPainterDoc::SelectShape(CPoint point)
{
	POSITION Pos=NULL;
	CBasePoint* pShape=NULL;
	if(m_ShapesList.GetCount()>0)
		Pos=m_ShapesList.GetHeadPosition();
	while(Pos!=NULL)
	{
		pShape=(CBasePoint*)m_ShapesList.GetNext(Pos);
		if(pShape->PointInShape(point)) 
		{
			m_pCurShape=pShape; return TRUE;
		}
	}
	return FALSE;
};
