// Shapes.h 

////////////////////////////////////////////////////
//  

class CBasePoint: public CObject
{
 	DECLARE_SERIAL(CBasePoint)   
 protected:  		//   
	virtual void Serialize(CArchive& ar);
 public:		
	//
	CBasePoint(CPoint point); //  
	CBasePoint();//  
	~CBasePoint(){}; //
// 
	double m_dScale; // 
	LONG m_x;
	LONG m_y;
	COLORREF m_Color; //
	LONG m_Step; //
	BOOL m_FlagShift; //  Shift
	BOOL m_FlagCtrl; //  Ctrl
// 
	//     -   
	virtual void Show(CDC *pDC);
	//     
	virtual void GetRegion(CRgn &Rgn);
	//   -     
	virtual BOOL PointInShape(CPoint point);
	//    
	virtual CPoint Transform(const CPoint &point,
	       const CPoint &point0, double ang, int a, int b);
	//  
	virtual void SetColor(COLORREF color){m_Color=color;};
	virtual void SetStep(LONG step){m_Step=step;};
	//    
	virtual void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags); //
	virtual void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);   //

};

////////////////////////////////////////////////////
// 
class CCircle: public CBasePoint
{
 	DECLARE_SERIAL(CCircle)   
 protected:  	//   	
	virtual void Serialize(CArchive& ar);
 public:		
	//
	CCircle(CPoint point, WORD r);
	CCircle();
	~CCircle(){};
//
	WORD m_wRadius; // 
//
	//    
	virtual void Show(CDC *pDC);
	//     
	virtual void GetRegion(CRgn &Rgn);
};

////////////////////////////////////////////////////
// 
class CSquare: public CBasePoint
{
 	DECLARE_SERIAL(CSquare)   
 protected:  	//   	
	virtual void Serialize(CArchive& ar);
 public:		
	//
	CSquare(CPoint point, WORD s);
	CSquare();
	~CSquare(){};
//
	WORD m_wSide; // 
//
	//    
	virtual void Show(CDC *pDC);
	//     
	virtual void GetRegion(CRgn &Rgn);
};

////////////////////////////////////////////////////
// 
#define MAXPOLIGONLENGTH 100
class CPoligon: public CBasePoint
{
 	DECLARE_SERIAL(CPoligon)   
 protected:  	//   	
	virtual void Serialize(CArchive& ar);
 public:		
	//
	CPoligon();
	CPoligon(CPoint point);
	~CPoligon();
//
	POINT m_Points[MAXPOLIGONLENGTH]; //  
	WORD m_nIndex;
//
	//    
	virtual void Show(CDC *pDC);
	//     
	virtual void GetRegion(CRgn &Rgn);
	// 
	BOOL AddPoint(CPoint point);
	//   
	void Transform(double ang, int a, int b);
	//    
	virtual void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags); //
};

////////////////////////////////////////////////////
// 3D 
struct POINT3D
{
	LONG x, y, z;
}; 

//   
struct  Perspective
{
   POINT3D O;				//    
   double rho, theta, phi,  //     (E)
           d;              //  E  
   WORD with_perspective;   //1- .  ; 0-.
};

////////////////////////////////////////////////////
// C3DPoligon
//
class C3DPoligon: public CPoligon
{
 	DECLARE_SERIAL(C3DPoligon)   
 protected:  	//   	
	virtual void Serialize(CArchive& ar);
 public:		
 	//
	C3DPoligon();
	C3DPoligon(CPoint point);
	~C3DPoligon();
// 
	POINT3D m_3DPoints[MAXPOLIGONLENGTH]; //  	  
// 		
	virtual void Show(CDC *pDC);//    
	BOOL AddPoint(POINT3D point); // 
	void MakeProjection(Perspective P); //   
};


////////////////////////////////////////////////////
// C3DShape
class C3DShape: public CBasePoint
{
 	DECLARE_SERIAL(C3DShape)   
 protected:  	//   	
	virtual void Serialize(CArchive& ar);
 public:		
	//
	C3DShape();
	C3DShape(CPoint point);
	~C3DShape();
//
	Perspective m_Percpective; // 
	CTypedPtrList<CObList, C3DPoligon*> m_PtrPoligonList; //    
//
	//    
	virtual void Show(CDC *pDC);
	//   -     
	virtual BOOL PointInShape(CPoint point);
	//  
	void AddPoligon(C3DPoligon *pPoligon);
	//  
	void MakeProjection();
	//    
	virtual void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags); //
};

////////////////////////////////////////////////////
// CCube
class CCube: public C3DShape
{
 	DECLARE_SERIAL(CCube)   
 protected:  	//   	
	virtual void Serialize(CArchive& ar);
 public:		
	//
	CCube();
	CCube(CPoint BasePoint, WORD side);
	~CCube(){};
	void Create(CPoint point, WORD side);
 //
 WORD m_wSide; // 
};
